package com.ijinshan.rt.common;

import android.os.ParcelFileDescriptor;
import android.content.pm.IPackageDataObserver;
import android.content.pm.IPackageMoveObserver;
import com.cm.plugincluster.root.bean.FileInfo;
import com.ijinshan.rt.common.JunkFileInfo;
import com.cm.plugincluster.root.bean.JunkFileInfoNew;
import com.ijinshan.rt.common.IDelCacheObserver;
import com.ijinshan.rt.common.AppDirData;


interface IRootKeeper {
	int GetVersion();
	void exit();
	
	boolean exec(String strCmd);
	int execSh(String sh, out List<String> output);
	int execRc(String strCmd);
	boolean forceStopPackage(String strPkg);
	String	dumpNotification();


	boolean UpdateUid();
	
	boolean isClientSoExistInProc (String soFileName, int nPid);
	
	boolean DeleteFromDeviceAdmin(String strPkg);
	

	
	boolean SetMemoryModuleVersion(int ver);
	int     GetMemoryModuleVersion();
	void reboot(String reason);
	
	void	EnableComponent(in android.content.ComponentName comp, boolean bEnable);
	
	void deleteApplicationCacheFiles(in String packageName, IPackageDataObserver observer);
	
	boolean isFileExist(in String filePath);
	
	boolean deleteFile(in String path);

	void deleteFiles(in String path, IDelCacheObserver observer);
	boolean execWithTimeOut(String strCmd, long nTime);
	
	boolean AyncExec(String strCmd);

	void movePackage(String packageName, IPackageMoveObserver observer, int flags);
	
	long getFileSize(String pathFile);
	
	int GetPidByName(String procName);
	boolean CheckMarkInProcMaps(int nPid, String strMark);
	
	List<FileInfo> EnumFiles(String path);
	
	boolean isFile(in String filePath);
	
	String listProcFdInfo(int pid);
	
	String dumpActivityManager(String param);
	
	boolean moveFileOrFolder(String srcPath, String dstPath, boolean isFile);
	
	List<JunkFileInfo> enumJunkFiles(String path);
	
	AppDirData dumpSystemAppDirInfo(String libPath, String pkgs);
	
	int moveApkToSD(String packageName, String sdcardPath);
	
	JunkFileInfoNew enumJunkFilesNew(String path,String libPath);
	
	String convertRootCacheCleanCloudPath(String rootPath,String path,String pkgName);
	
	List<String> convertRootCacheCleanCloudPathREG(String rootPath,String path,String pkgName);
	
	long getPathFileSize(String path);

    String queryReadOnlyDataBase(String dbPath, String queryString, String queryJsonDataFormat);
    
	void deleteFilesLeftFoder(in String path, IDelCacheObserver observer);

    boolean writeFile(String fileAbsolutePath, String strContent);
}
